/* Modifikation des Datums fr einen Prozess,
 * gemacht aus dem Programm   iwatchex.cpp   IWatch Extension
 * 1998 by c't / Matthias Withopf
 * 07/03 h#s
 */

#if defined(_MSC_VER)
#pragma auto_inline(off)
#pragma optimize("s",on)
#pragma comment(linker,"/OPT:NOWIN98 /NOD /RELEASE /LARGEADDRESSAWARE")
#pragma comment(linker,"/DLL /EXPORT:_init@8,@2,NONAME")
#endif

#include "iwatchsu.h"
#include "FakeHelp.h"

Boolean IsWin95=False;

MYDATE MyDate;

char *KernelNames[6]={"KERNEL32.DLL",
 "GetProcAddress","GetSystemTime","GetLocalTime","GetSystemTimeAsFileTime",
 "IsDebuggerPresent"};
// wird beim Start durch Handle und Einsprungadressen ersetzt
// Knnte eigentlich auch alles (bis auf MyDate) "shared" sein!

// Angezapfte Funktionen MyXxx
FARPROC WINAPI MyGetProcAddress(HMODULE hModule,LPCSTR lpProcName);

VOID WINAPI MyGetSystemTime(LPSYSTEMTIME st) {
 GetSystemTime(st);
 st->wYear=MyDate.year;
 st->wMonth=MyDate.month;
 st->wDay=MyDate.day;
}

VOID WINAPI MyGetLocalTime(LPSYSTEMTIME st) {
 GetLocalTime(st);
 st->wYear=MyDate.year;
 st->wMonth=MyDate.month;
 st->wDay=MyDate.day;
}

VOID WINAPI MyGetSystemTimeAsFileTime(LPFILETIME ft) {
 SYSTEMTIME st;
 MyGetSystemTime(&st);
 SystemTimeToFileTime(&st,ft);
}

BOOL MyIsDebuggerPresent(VOID) {
 return FALSE;
}

// Liste der angezapften Funkionen in der Reihenfolge von KernelNames[]
FARPROC MyKernelAddrs[elemof(KernelNames)]={NULL,
 (FARPROC)MyGetProcAddress,(FARPROC)MyGetSystemTime,(FARPROC)MyGetLocalTime,
 (FARPROC)MyGetSystemTimeAsFileTime,(FARPROC)MyIsDebuggerPresent};

FARPROC WINAPI MyGetProcAddress(HMODULE hModule,LPCSTR lpProcName) {
 FARPROC R;
 R=GetProcAddress(hModule,lpProcName);
 if (R) for (int i=1; i<elemof(KernelNames); i++) {
  if (R==(FARPROC)KernelNames[i]) R=MyKernelAddrs[i];
 }
 return R;
}

// Funktionsaufrufe patchen
// WICHTIG: Diese DLL darf nicht gepatcht werden!
typedef enum {
 iwh_Ok = 0,
 iwh_UnknownError,
 iwh_NoExeBase,
 iwh_BadExeBase,
 iwh_BadDosSignature,
 iwh_BadNTSignature,
 iwh_BadImportDescriptor,
 iwh_IllegalImportDescriptor,
} THookErrorCode,* PHookErrorCode;

#if defined(CPU_INTEL)
FARPROC SkipW95Thunk(FARPROC FuncAddr) {
 if (IsWin95 && (DWORD)FuncAddr>=0x80000000) {
  if (!IsBadReadPtr(FuncAddr,10) && *(PBYTE)FuncAddr==0x68) {	// push Konstante
   return *(FARPROC*)((PBYTE)FuncAddr + 1);
  }
 }
 return FuncAddr;
}
#else
# define SkipW95Thunk(x) (x)
#endif

THookErrorCode HookFunctions(Pointer ExeBase) {
 if (!ExeBase) {
  return iwh_NoExeBase;
 }
 if (IsBadReadPtr(ExeBase,sizeof(IMAGE_NT_HEADERS))) {
  return iwh_BadExeBase; 
 }
 PIMAGE_DOS_HEADER DOSHeader=(PIMAGE_DOS_HEADER)ExeBase;
 if (DOSHeader->e_magic!=IMAGE_DOS_SIGNATURE) {
  return iwh_BadDosSignature; 
 }
 PIMAGE_NT_HEADERS NTHeader=(PIMAGE_NT_HEADERS)((PByte)DOSHeader + DOSHeader->e_lfanew);
 if (NTHeader->Signature!=IMAGE_NT_SIGNATURE) {
  return iwh_BadNTSignature; 
 }
 PIMAGE_IMPORT_DESCRIPTOR ImportDesc=(PIMAGE_IMPORT_DESCRIPTOR)((PByte)ExeBase
   + NTHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);

 Boolean RestoreProtection=False;
 DWORD   OldProtection;
  // Tabelle mit Funktionsadresse
  // Bei Programmen, die mit Visual C++ erzeugt wurden, ist diese Tabelle ReadOnly.
  // Da sie gepatched werden soll, mu zuvor auf Read/Write gendert werden.
 Pointer FuncTab=(Pointer)NTHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IAT].VirtualAddress;
 LongWord FuncTabSize =   NTHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IAT].Size;
 if (FuncTab && FuncTabSize) {
  FuncTab = (PByte)ExeBase + (LongWord)FuncTab;
  MEMORY_BASIC_INFORMATION MI;
  VirtualQuery(FuncTab,&MI,sizeof MI);
  if (MI.Protect==PAGE_READONLY) {
   VirtualProtect(FuncTab,FuncTabSize,PAGE_READWRITE,&OldProtection);
   RestoreProtection=True;
  }
 }
 if (ImportDesc==(PIMAGE_IMPORT_DESCRIPTOR)NTHeader) {
  return iwh_BadImportDescriptor; 
 }
 if (IsBadReadPtr(ImportDesc,1)) {
  return iwh_IllegalImportDescriptor; 
 }

 for (;ImportDesc->Name;++ImportDesc) {
  for (PIMAGE_THUNK_DATA Thunk = (PIMAGE_THUNK_DATA)((PByte)ExeBase + (LongWord)ImportDesc->FirstThunk);Thunk->u1.Function;++Thunk) {
   FARPROC F1=SkipW95Thunk((FARPROC)Thunk->u1.Function);
   for (int i=1; i<elemof(KernelNames); i++) {
    if (F1==(FARPROC&)KernelNames[i]) {
     FARPROC NewAddr=MyKernelAddrs[i];
     DWORD Result;
     BOOL f=WriteProcessMemory(GetCurrentProcess(),Thunk,&NewAddr,sizeof(NewAddr),&Result);
     if (!f) {
      char tmp[256]; 
      wsprintfA(tmp,T("Error patching function %s at 0x%08lX, GetLastError() -> %ld"),KernelNames[i],Thunk,GetLastError()); 
      OutputDebugStringA(tmp);
     }
    }
   }
  }
 }
 if (RestoreProtection) {
  DWORD Dummy;
  VirtualProtect(FuncTab,FuncTabSize,OldProtection,&Dummy);
 }
 return iwh_Ok;
}

#if defined(__BORLANDC__)
extern "C" LongWord _export _stdcall _INIT(LongWord Action,Pointer Param) {
#else
extern "C" LongWord WINAPI init(LongWord Action,Pointer Param) {
#endif
// wird durch Patch der .EXE aufgerufen (besser: CreateRemoteThread())
 LongWord Result=False;
 switch (Action) {

  case iwa_SetDllBase: {
   SYSTEM_INFO SI;
   GetSystemInfo(&SI);
   LongWord StackSize=2*SI.dwPageSize;
   Pointer p=VirtualAlloc(NULL,StackSize,MEM_COMMIT,PAGE_READWRITE);
   Result = (LongWord)p + StackSize - 16;
  }break;

  case iwa_PatchFunctions: {
   if (!Param) Param=GetModuleHandle(NULL);
   THookErrorCode ErrorCode=HookFunctions(Param);
   Result=ErrorCode==iwh_Ok;
  }break;

  case iwa_SetTime: {
   MyDate.all=(DWORD)Param;
  }break;
 }
 return Result;
}

void NamesToAddrs(void) {
// ersetzt die (Kernel-) Namen in der obigen Tabelle durch Adressen
 if ((GetVersion()&0xC0000000)==0xC0000000) IsWin95=True;
 (HINSTANCE&)KernelNames[0]=GetModuleHandleA(KernelNames[0]);
 if (KernelNames[0]) for (int i=1; i<elemof(KernelNames); i++) {
  (FARPROC&)KernelNames[i]=SkipW95Thunk(GetProcAddress((HINSTANCE)KernelNames[0],KernelNames[i]));
 }
}

extern "C" BOOL WINAPI _DllMainCRTStartup(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID /*lpvReserved*/) {
 switch(fdwReason) {
  case DLL_PROCESS_ATTACH: DisableThreadLibraryCalls(hinstDLL); NamesToAddrs(); nobreak;
  case DLL_PROCESS_DETACH: return TRUE;
 }
 return FALSE;
}
